using System;

/// @author  Vesa Lappalainen
/// @version 22.10.2012
/// <summary>
/// Harjoitellaan merkkijonojen pilkkomista.
/// </summary>
public class MjPilkkominen
{
    /// <summary>
    /// Kysellaan kayttajalta merkkijonoja ja
    /// tehdaan niista taulukkoja, lasketaan lukuja
    /// yhteen ja tulostellaan.
    /// </summary>
    public static void Main()
    {
        char[] erottimet = [' ', ';', ',' ];
        
        // Console.Write("Kirjoita jono jossa sanoja > ");
        // string mj = Console.ReadLine();
        // Console.WriteLine(mj);
        string mj = "1 2 3 4";
        string[] pilkottu = mj.Split(erottimet);
        TulostaPalat(pilkottu);
        
        int[] t1 = MerkkijonoLuvuiksi("1 99 3", [' ']);
        if (t1 != null)
        {
            string luvutPotkossa = string.Join(",", t1);
            Console.WriteLine(luvutPotkossa);
        }
    }

    
    /// <summary>
    /// Aliohjelma muuttaa annetun merkkijonon kokonaislukutaulukoksi
    /// siten, etta eri luvut erotellaan annetun merkkitaulukon (erotinmerkkien)
    /// perusteella. Alkuperäisen syötteen alusta ja lopusta poistetaan välilyönnit.
    /// Tyhjistä paikoista tulee 0.  3,,   3,0,0
    /// </summary>
    /// <param name="lukusyote">Muunnettava merkkijono</param>
    /// <param name="erottimet">Sallitut erotinmerkit merkkitaulukossa</param>
    /// <returns>Merkkijonosta selvitetty kokonaislukutaulukko. null jos yksikin luku väärin</returns>
    /// <example>
    /// <pre name="test">
    ///    MerkkijonoLuvuiksi("1 2 3", [' ']) === new int[]{1,2,3};
    ///    MerkkijonoLuvuiksi(" ,,1;;3  ;5  ", [' ', ',', ';']) === new int[]{0,0,1,0,3,0,0,5};
    ///    MerkkijonoLuvuiksi("1 3k 5", new char[] {' '}) === null;
    /// </pre>
    /// </example>
    public static int[] MerkkijonoLuvuiksi(string lukusyote, char[] erottimet)
    {
        string[] pilkottu = lukusyote.Trim().Split(erottimet);
        int[] luvut = new int[pilkottu.Length];
        for (int i = 0; i < pilkottu.Length; i++)
        {
            string pala = pilkottu[i];
            if (string.IsNullOrWhiteSpace(pala))
            {
                luvut[i] = 0;
            }
            else
            {
                if (!int.TryParse(pala, out luvut[i])) return null;
            }
        }
        return luvut;
    }
    
    
    public static void TulostaPalat(string[] palat)
    {
        foreach (string pala in palat)
        {
            Console.WriteLine($"Pala: \"{pala}\"");   
        }

        Console.WriteLine("----------------------------");
    }
    
}